include:
  # Include instance Auto-DevOps
  # https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Auto-DevOps.gitlab-ci.yml
  - template: Auto-DevOps.gitlab-ci.yml

# until we can safely target transient errors, let's avoid some headaches.
build:
  retry: 2
test:
  retry: 2

# Config

variables:
  POSTGRES_ENABLED: "false"
  # Disable Auto-DevOps CD/Auth-Deploy jobs by default.
  BROWSER_PERFORMANCE_DISABLED: 1 # http specific job
  REVIEW_DISABLED: 1  # dev/review jobs
  STAGING_DISABLED: 1 # staging jobs
  CI_DEPLOY_FREEZE: 1 # prod jobs
  CLUSTER_IMAGE_SCANNING_DISABLED: 1 # requires CD integration & public repo or ultimate license
  DAST_DISABLED: 1 # requires CD integration & public repo or ultimate license

# Blocks

.netrc:
  script:
    - |-
      #
      echo -e "\e[0Ksection_start:`date +%s`:netrc[collapsed=true]\r\e[0K\e[1;32mHandle .netrc\e[21;0m"
      if test -n "$CI_SERVER_HOST" && test -n "$NETRC_USER" && test -n "$NETRC_PASSWORD"; then
        echo "- Use NETRC_* vars"
        echo "machine ${CI_SERVER_HOST} login ${NETRC_USER} password ${NETRC_PASSWORD}" > ~/.netrc
      elif test -n "$CI_JOB_TOKEN"; then
        echo "- Use CI_JOB_TOKEN"
        echo "machine ${CI_SERVER_HOST} login gitlab-ci-token password ${CI_JOB_TOKEN}" > ~/.netrc
      else
        echo "- nothing to do"
      fi
      echo -e "\e[0Ksection_end:`date +%s`:netrc\r\e[0K"

# CI

code_intelligence_go:
  before_script:
    - !reference [.netrc, script]

gosec-sast:
  before_script:
    - !reference [.netrc, script]

# CD

# Add stop staging possibility
staging:
  environment:
    on_stop: stop_staging

stop_staging:
  extends: stop_review
  #needs:
  #  - staging
  environment:
    name: staging
  rules:
    - !reference [staging, rules]
